#include "math.h" // inclure la bibliothèque math.h (pour la fonction log10 ici)

int photodiode = A0; //  la photodiode est sur la PIN A0

double mesure ; // déclaration de la variable mesure
float tension ; // déclaration de la variable tension
float tension0 = 0.0 ; // déclaration de la valeur de la tension avant la cuve
double absorbanceBLANC = 0.0 ; // déclaration de la variable absorbanceBLANC
double absorbance ; // déclaration de la variable absorbance


void setup() { // début de la fonction "setup" qui s'exécute une seule fois
  pinMode(photodiode, INPUT); //photodiode est une entrée
  Serial.begin(9600); // initialiser la communication entre la carte et l'ordinateur
}


void loop() { // début de la fonction "loop" qui s'exécute en boucle tant que la carte est relié à une alimentation

// Partie I : calcul de la tension
        mesure = analogRead(photodiode); // lire la valeur numérique récupérée par la photodiode
        tension = (5.0*mesure)/1023.0; // calcul de la tension en volt (V)
        Serial.print("Tension : "); //afficher le texte entre "" ici : Tension
        Serial.print(tension); // afficher la valeur de la variable tension sur le moniteur série
        Serial.println(" V"); //afficher le texte entre "" ici : V puis sauter une ligne

// Partie II : calcul de l'absorbance
        absorbance = ((log10 (tension/tension0)) - absorbanceBLANC); // calcul de l'absorbance
        Serial.print("Absorbance : "); //afficher le texte entre "" ici : Absorbance
        Serial.println(absorbance); // afficher la valeur de la variable absorbance sur le moniteur série
        Serial.println(""); //afficher le texte entre "" ici rien puis sauter une ligne

  delay(1500); // attendre 1500 ms soit 1,5 s
}
