#include "math.h" // inclure la bibliothèque math.h (pour la fonction log10 ici)

int photodiode = A0; //  la photodiode est sur la PIN A0

double mesure ; // déclaration de la variable mesure
float tension ; // déclaration de la variable tension
float tension0 ; // déclaration de la valeur de la tension avant la cuve
double Ablanc ; // déclaration de la variable Ablanc (correspond à l'absorbance à blanc)
double absorbance ; // déclaration de la variable absorbance
int etat = 0 ; // déclaration de la variable etat
int E = 1 ;
int U = 2 ;
int A = 3 ;
int n = 0;

void setup() { // début de la fonction "setup" qui s'exécute une seule fois
  pinMode(photodiode, INPUT); //photodiode est une entrée
  Serial.begin(9600); // initialiser la communication entre la carte et l'ordinateur
  Serial.println("Pour realiser l'etalonnage, appuyez sur E.");
  Serial.println("");
}

void loop() { // début de la fonction "loop" qui s'exécute en boucle tant que la carte est relié à une alimentation

// Partie I : étalonnage
    char carac = Serial.read(); // lecture des données en entrée du port série (ce que l'utilisateur écrit)
    
    if (carac == 'E') // si la touche pressée est E
    { 
      etat = E;
      Serial.println("Placer la photodiode de sorte à ce que le laser l'eclaire."); //afficher le texte entre ""
      Serial.println("Lorsque vous etes pret, appuyez sur la touche U."); //afficher le texte entre ""
    }
   
    if (etat == E && carac == 'U') // si la touche pressée est U
    { 
       etat = U;
       tension0 = (analogRead(photodiode) * (5.0/1023.0)); // mesure de la tension avant la cuve
       Serial.println("La tension avant la cuve est de : ");
       Serial.print(tension0);
       Serial.println("  V");
       Serial.println("");
       Serial.println("Placer maintenant une cuve rempli du solvant pour effectuer le blanc."); //afficher le texte entre ""
       Serial.println("Lorsque vous etes pret, appuyez sur la touche A."); //afficher le texte entre ""
     }
      
     if (etat == U && carac == 'A') // si la touche pressée est A
     { 
     etat = A;
     mesure = analogRead(photodiode); // lire la valeur récupérée par la photodiode
     tension = (5.0/1023.0)*mesure; // calcul de la tension en volt (V)
     Ablanc = -(log10 (tension0/tension)); // calcul de l'absorbance à blanc
     Serial.println("L'absorbance à blanc est de : ");
     Serial.println(Ablanc);
     Serial.println("");
     Serial.println("Vous pouvez maintenant realiser vos mesures. Pour cela, appuyez sur M.");
     }
          


// Partie II : mesures
      if (carac == 'M') // si la touche pressée est A
      { 
        n = n + 1;
        mesure = analogRead(photodiode); // lire la valeur récupérée par la photodiode
        tension = (5.0/1023.0)*mesure; // calcul de la tension en volt (V)
        absorbance = ((-log10 (tension0/tension)) - Ablanc); // calcul de l'absorbance

        Serial.print("Mesure numéro : "); //afficher le texte entre "" ici : Tension
        Serial.println(n); //afficher le texte entre "" ici : Tension
        Serial.print("Tension : "); //afficher le texte entre "" ici : Tension
        Serial.print(tension); // afficher la valeur de la variable tension sur le moniteur série
        Serial.println(" V"); //afficher le texte entre "" ici : V         Serial.print("    ;    "); //séparation par point virgule des différents éléments à affiche
        Serial.print("Absorbance : "); //afficher le texte entre "" ici : Absorbance
        Serial.println(absorbance); // afficher la valeur de la variable absorbance sur le moniteur série
        Serial.println("");
      }
    
  delay(1500); // attendre 1500 ms soit 1,5 s
}
